
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Saved_articlesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const saved_articles = await db.saved_articles.create(
            {
                id: data.id || undefined,
        
        folder_name: data.folder_name
        ||
        null
            ,
            
        saved_at: data.saved_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await saved_articles.setUser( data.user || null, {
            transaction,
        });
        
        await saved_articles.setArticle( data.article || null, {
            transaction,
        });
        

        

        

        return saved_articles;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const saved_articlesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                folder_name: item.folder_name
            ||
            null
            ,
            
                saved_at: item.saved_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const saved_articles = await db.saved_articles.bulkCreate(saved_articlesData, { transaction });

        // For each item created, replace relation files
        

        return saved_articles;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const saved_articles = await db.saved_articles.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.folder_name !== undefined) updatePayload.folder_name = data.folder_name;
        
        
        if (data.saved_at !== undefined) updatePayload.saved_at = data.saved_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await saved_articles.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await saved_articles.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.article !== undefined) {
            await saved_articles.setArticle(
              
              data.article,
              
              { transaction }
            );
        }
        

        
        

        

        return saved_articles;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const saved_articles = await db.saved_articles.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of saved_articles) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of saved_articles) {
                await record.destroy({transaction});
            }
        });


        return saved_articles;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const saved_articles = await db.saved_articles.findByPk(id, options);

        await saved_articles.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await saved_articles.destroy({
            transaction
        });

        return saved_articles;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const saved_articles = await db.saved_articles.findOne(
            { where },
            { transaction },
        );

        if (!saved_articles) {
            return saved_articles;
        }

        const output = saved_articles.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await saved_articles.getUser({
            transaction
        });
        
        
        output.article = await saved_articles.getArticle({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.library_articles,
        as: 'article',
        
        where: filter.article ? {
          [Op.or]: [
            { id: { [Op.in]: filter.article.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.article.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.folder_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'saved_articles',
                        'folder_name',
                        filter.folder_name,
                    ),
                };
            }
            

            
            

            
            if (filter.saved_atRange) {
                const [start, end] = filter.saved_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    saved_at: {
                    ...where.saved_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    saved_at: {
                    ...where.saved_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.saved_articles.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'saved_articles',
                        'folder_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.saved_articles.findAll({
            attributes: [ 'id', 'folder_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['folder_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.folder_name,
        }));
    }

    
};

